
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spring Boot MyBatis 通用Mapper插件集成  good / iVAN</title>

    <meta name="description" content="Spring Boot MyBatis 通用Mapper插件集成  good 看本文之前,请确保你已经在SpringBoot中集成MyBatis,并能正常使用.如果没有,那么请先移步 http://blog.csdn.net/catoop/article/details/50553714 做了解后,再按本文步骤操作. 使用MyBatis在我们通过xml集中配置SQL,并通过创建接口Mapper文件来完成持久化DAO层(mybatis内部使用的是动态代理,所以我们不需要自己编写实现类). 然而在实际开发中,单表操作非常多,如果你也想像JPA.JDBC那样做一个所谓的Base">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Spring Boot MyBatis 通用Mapper插件集成  good</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>看本文之前，请确保你已经在SpringBoot中集成MyBatis，并能正常使用。<br />如果没有，那么请先移步 <a href="http://blog.csdn.net/catoop/article/details/50553714" rel="external nofollow noreferrer">http://blog.csdn.net/catoop/article/details/50553714</a> 做了解后，再按本文步骤操作。</p>
<p>使用MyBatis在我们通过xml集中配置SQL，并通过创建接口Mapper文件来完成持久化DAO层（mybatis内部使用的是动态代理，所以我们不需要自己编写实现类）。</p>
<p>然而在实际开发中，单表操作非常多，如果你也想像JPA、JDBC那样做一个所谓的BaseDao。那么可以实现一个通用Mapper来达到目的。现在有现成的通用Mapper插件，我们无需重新创造轮子（代码是开源的，你也可以自己在其基础上修改）。</p>
<p>通用Mapper插件网址：<a href="http://git.oschina.net/free/Mapper" rel="external nofollow noreferrer">http://git.oschina.net/free/Mapper</a></p>
<hr>
<br />下面是使用方法（本文直接将分页插件PageHelper也集成了）：<br />一、添加或修改pom依赖</p>
<pre><code>        &lt;!-- MyBatis --&gt;
&lt;!--        &lt;dependency&gt; --&gt;
&lt;!--            &lt;groupId&gt;org.mybatis.spring.boot&lt;/groupId&gt; --&gt;
&lt;!--            &lt;artifactId&gt;mybatis-spring-boot-starter&lt;/artifactId&gt; --&gt;
&lt;!--            &lt;version&gt;1.0.1-SNAPSHOT&lt;/version&gt; --&gt;
&lt;!--        &lt;/dependency&gt; --&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;org.mybatis&lt;/groupId&gt;
            &lt;artifactId&gt;mybatis&lt;/artifactId&gt;
            &lt;version&gt;3.3.0&lt;/version&gt;
        &lt;/dependency&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;org.mybatis&lt;/groupId&gt;
            &lt;artifactId&gt;mybatis-spring&lt;/artifactId&gt;
            &lt;version&gt;1.2.3&lt;/version&gt;
        &lt;/dependency&gt;
        &lt;!-- 分页插件 --&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;com.github.pagehelper&lt;/groupId&gt;
            &lt;artifactId&gt;pagehelper&lt;/artifactId&gt;
            &lt;version&gt;4.1.1&lt;/version&gt;
        &lt;/dependency&gt;
        &lt;!--通用Mapper插件--&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;tk.mybatis&lt;/groupId&gt;
            &lt;artifactId&gt;mapper&lt;/artifactId&gt;
            &lt;version&gt;3.3.4&lt;/version&gt;
        &lt;/dependency&gt;
</code></pre>
<p>这里说一下，文章开始指定的那篇文章中直接依赖的mybatis的starter。因为本文在集成通用Mapper的时候直接使用出现了错误，所以将mybatis的starter中的Java类（它本身只有2个Java类，非常简单）拷贝到工程中，注释掉了头部的//@ConditionalOnBean(DataSource.class)，你不用去找那2个类的源码了，下面会粘贴出来。</p>
<p>二、将下面4个Java类加入到工程中</p>
<p>将文件<br />MybatisAutoConfiguration.java<br />MyBatisMapperScannerConfig.java<br />MybatisProperties.java<br />MyMapper.java<br />添加到 org.springboot.sample.config.mybatis 中（包名根据自己工程修改）</p>
<p>最有一个MyMapper.java要特别注意，不要把MyMapper放到同<strong>其他Mapper</strong>一起，该类不能被当做<strong>普通Mapper</strong>一样被扫描，否则会出错。</p>
<pre><code>package org.springboot.sample.config.mybatis;

import java.util.Properties;

import javax.annotation.PostConstruct;
import javax.sql.DataSource;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.ibatis.plugin.Interceptor;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.SqlSessionTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.AutoConfigureAfter;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.DefaultResourceLoader;
import org.springframework.core.io.Resource;
import org.springframework.core.io.ResourceLoader;
import org.springframework.util.Assert;
import org.springframework.util.StringUtils;

import com.github.pagehelper.PageHelper;

/**
 * {@link EnableAutoConfiguration Auto-Configuration} for Mybatis. Contributes a
 * {@link SqlSessionFactory} and a {@link SqlSessionTemplate}.
 *
 * If {@link org.mybatis.spring.annotation.MapperScan} is used, or a configuration file is
 * specified as a property, those will be considered, otherwise this auto-configuration
 * will attempt to register mappers based on the interface definitions in or under the
 * root auto-configuration package.
 *
 * @author Eddú Meléndez
 * @author Josh Long
 */
@Configuration
@ConditionalOnClass({ SqlSessionFactory.class, SqlSessionFactoryBean.class })
//@ConditionalOnBean(DataSource.class)
@EnableConfigurationProperties(MybatisProperties.class)
@AutoConfigureAfter(DataSourceAutoConfiguration.class)
public class MybatisAutoConfiguration {

    private static Log log = LogFactory.getLog(MybatisAutoConfiguration.class);

    @Autowired
    private MybatisProperties properties;

    @Autowired(required = false)
    private Interceptor[] interceptors;

    @Autowired
    private ResourceLoader resourceLoader = new DefaultResourceLoader();

    @PostConstruct
    public void checkConfigFileExists() {
        if (this.properties.isCheckConfigLocation()) {
            Resource resource = this.resourceLoader
                    .getResource(this.properties.getConfig());
            Assert.state(resource.exists(),
                    "Cannot find config location: " + resource
                            + " (please add config file or check your Mybatis "
                            + "configuration)");
        }
    }

    @Bean(name = "sqlSessionFactory")
    @ConditionalOnMissingBean
    public SqlSessionFactory sqlSessionFactory(DataSource dataSource) throws Exception {
        SqlSessionFactoryBean factory = new SqlSessionFactoryBean();
        factory.setDataSource(dataSource);
        if (StringUtils.hasText(this.properties.getConfig())) {
            factory.setConfigLocation(
                    this.resourceLoader.getResource(this.properties.getConfig()));
        } else {
            if (this.interceptors != null &amp;&amp; this.interceptors.length &gt; 0) {
                factory.setPlugins(this.interceptors);
            }
            factory.setTypeAliasesPackage(this.properties.getTypeAliasesPackage());
            factory.setTypeHandlersPackage(this.properties.getTypeHandlersPackage());
            factory.setMapperLocations(this.properties.getMapperLocations());
        }
        return factory.getObject();
    }

    @Bean
    @ConditionalOnMissingBean
    public SqlSessionTemplate sqlSessionTemplate(SqlSessionFactory sqlSessionFactory) {
        return new SqlSessionTemplate(sqlSessionFactory,
                this.properties.getExecutorType());
    }

    /**
     * 分页插件
     *
     * @param dataSource
     * @return
     * @author SHANHY
     * @create  2016年2月18日
     */
    @Bean
    public PageHelper pageHelper(DataSource dataSource) {
        log.info("注册MyBatis分页插件PageHelper");
        PageHelper pageHelper = new PageHelper();
        Properties p = new Properties();
        p.setProperty("offsetAsPageNum", "true");
        p.setProperty("rowBoundsWithCount", "true");
        p.setProperty("reasonable", "true");
        pageHelper.setProperties(p);
        return pageHelper;
    }

}

</code></pre>
<pre><code>package org.springboot.sample.config.mybatis;

import java.util.Properties;

import org.springframework.boot.autoconfigure.AutoConfigureAfter;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import tk.mybatis.spring.mapper.MapperScannerConfigurer;

/**
 * MyBatis扫描接口，使用的tk.mybatis.spring.mapper.MapperScannerConfigurer &lt;br/&gt;
 * 如果你不使用通用Mapper，可以改为org.xxx...
 *
 */
@Configuration
//TODO 注意，由于MapperScannerConfigurer执行的比较早，所以必须有下面的注解
@AutoConfigureAfter(MybatisAutoConfiguration.class)
public class MyBatisMapperScannerConfig {

    @Bean
    public MapperScannerConfigurer mapperScannerConfigurer() {
        MapperScannerConfigurer mapperScannerConfigurer = new MapperScannerConfigurer();
        mapperScannerConfigurer.setSqlSessionFactoryBeanName("sqlSessionFactory");
        mapperScannerConfigurer.setBasePackage("org.springboot.sample.mapper");
        Properties properties = new Properties();//设置通用mapper的属性
        // 这里要特别注意，<strong>不要把MyMapper放到 basePackage</strong> 中，也就是不能同<strong>其他Mapper</strong>一样被扫描到。
        properties.setProperty("mappers", MyMapper.class.getName());
        properties.setProperty("notEmpty", "false");
        properties.setProperty("IDENTITY", "MYSQL");
        mapperScannerConfigurer.setProperties(properties);
        return mapperScannerConfigurer;
    }

}

</code></pre>
<pre><code>package org.springboot.sample.config.mybatis;

import org.apache.ibatis.session.ExecutorType;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.core.io.Resource;

/**
 * Configuration properties for Mybatis.
 *
 * @author Eddú Meléndez
 */
@ConfigurationProperties(prefix = MybatisProperties.MYBATIS_PREFIX)
public class MybatisProperties {

    public static final String MYBATIS_PREFIX = "mybatis";

    /**
     * Config file path.
     */
    private String config;

    /**
     * Location of mybatis mapper files.
     */
    private Resource[] mapperLocations;

    /**
     * Package to scan domain objects.
     */
    private String typeAliasesPackage;

    /**
     * Package to scan handlers.
     */
    private String typeHandlersPackage;

    /**
     * Check the config file exists.
     */
    private boolean checkConfigLocation = false;

    /**
     * Execution mode.
     */
    private ExecutorType executorType = ExecutorType.SIMPLE;

    public String getConfig() {
        return this.config;
    }

    public void setConfig(String config) {
        this.config = config;
    }

    public Resource[] getMapperLocations() {
        return this.mapperLocations;
    }

    public void setMapperLocations(Resource[] mapperLocations) {
        this.mapperLocations = mapperLocations;
    }

    public String getTypeHandlersPackage() {
        return this.typeHandlersPackage;
    }

    public void setTypeHandlersPackage(String typeHandlersPackage) {
        this.typeHandlersPackage = typeHandlersPackage;
    }

    public String getTypeAliasesPackage() {
        return this.typeAliasesPackage;
    }

    public void setTypeAliasesPackage(String typeAliasesPackage) {
        this.typeAliasesPackage = typeAliasesPackage;
    }

    public boolean isCheckConfigLocation() {
        return this.checkConfigLocation;
    }

    public void setCheckConfigLocation(boolean checkConfigLocation) {
        this.checkConfigLocation = checkConfigLocation;
    }

    public ExecutorType getExecutorType() {
        return this.executorType;
    }

    public void setExecutorType(ExecutorType executorType) {
        this.executorType = executorType;
    }
}

</code></pre>
<pre><code>package org.springboot.sample.config.mybatis;

import tk.mybatis.mapper.common.Mapper;
import tk.mybatis.mapper.common.MySqlMapper;

/**
 * 被继承的Mapper，一般业务Mapper继承它
 *
 */
public interface MyMapper&lt;T&gt; extends Mapper&lt;T&gt;, MySqlMapper&lt;T&gt; {
    //TODO
    //FIXME 特别注意，该接口不能被扫描到，否则会出错
}

</code></pre>
<p>三、属性配置文件<br />属性配置文件中和文章开头指定的文章一样配置，没有什么修改，下面粘贴出来：</p>
<pre><code>mybatis.mapper-locations=classpath*:org/springboot/sample/mapper/sql/mysql/*Mapper.xml
mybatis.type-aliases-package=org.springboot.sample.entity
</code></pre>
<p>四、在业务Mapper中继承基础MyMapper接口</p>
<pre><code>public interface StudentMapper extends MyMapper&lt;Student&gt; {

    List&lt;Student&gt; likeName(String name);

    Student getById(int id);

    int add(Student stu);

    String getNameById(int id);

}
</code></pre>
<p>然后在Service中使用即可，后面就没什么说的了。</p>
<pre><code>@Service
public class StudentService {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Autowired
    private StudentMapper studentMapper;

    @TargetDataSource(name="ds2")
    public List&lt;Student&gt; likeName(String name){
        return studentMapper.likeName(name);
    }

    public int testSave(){
        Student stu = new Student();
        stu.setAge(33);
        stu.setName("测试新增");
        stu.setSumScore("66");
        stu.setAvgScore("22");
        return studentMapper.insert(stu);//这里调用的是基础Mapper中的insert方法
    }

}
</code></pre>
<p>最后还有一点要说明，使用公共Mapper“可能”需要对实体类进行修改。如果你的实体字段和数据库字段不一致（或者实体名称和数据库表名不一致），这样才需要修改，例如：</p>
<pre><code>/**
 * 学生实体
 *
 * @author   单红宇(365384722)
 * @myblog  http://blog.csdn.net/catoop/
 * @create    2016年1月12日
 */
public class Student implements Serializable{

    @Id
    private int id;
    private String name;
    @Column(name="SCORE_SUM")
    private String sumScore;
    @Column(name="SCORE_AVG")
    private String avgScore;
    private int age;

    // getter setter 

}
</code></pre>
<p>其他没有什么可说的了，请至少要到 <a href="http://git.oschina.net/free/Mapper" rel="external nofollow noreferrer">http://git.oschina.net/free/Mapper</a> 把插件的其他说明再看一遍。</p>
<p></p>
<p> </p>
<p>1、Maven依赖，注意使用PageHelper时的版本必须与Mybatis版本对应</p>
<pre>&lt;!-- 添加Mybatis依赖 --&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;org.mybatis&lt;/groupId&gt;
            &lt;artifactId&gt;mybatis&lt;/artifactId&gt;
            &lt;version&gt;3.3.0&lt;/version&gt;
        &lt;/dependency&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;org.mybatis&lt;/groupId&gt;
            &lt;artifactId&gt;mybatis-spring&lt;/artifactId&gt;
            &lt;version&gt;1.2.3&lt;/version&gt;
        &lt;/dependency&gt;
        &lt;!-- pageHelper --&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;com.github.pagehelper&lt;/groupId&gt;
            &lt;artifactId&gt;pagehelper&lt;/artifactId&gt;
            &lt;version&gt;4.1.4&lt;/version&gt;
        &lt;/dependency&gt;</pre>
<p>2、需要在Mybatis的配置信息中使用PageHelper插件，mybatis-config.xml</p>
<pre>&lt;?xml version="1.0" encoding="utf-8" ?&gt;
&lt;!DOCTYPE configuration
        PUBLIC "-//mybatis.org//DTD Config 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-config.dtd"&gt;

&lt;configuration&gt;
    &lt;plugins&gt;
        &lt;plugin interceptor="com.github.pagehelper.PageHelper"&gt;
            &lt;!--指明数据库 4.0.0以后不需要设置此属性--&gt;
            &lt;property name="dialect" value="mysql"/&gt;
            &lt;!-- 该参数默认为false --&gt;
            &lt;!-- 设置为true时，会将RowBounds第一个参数offset当成pageNum页码使用 --&gt;
            &lt;!-- 和startPage中的pageNum效果一样--&gt;
            &lt;property name="offsetAsPageNum" value="true"/&gt;
            &lt;!-- 该参数默认为false --&gt;
            &lt;!-- 设置为true时，使用RowBounds分页会进行count查询 --&gt;
            &lt;property name="rowBoundsWithCount" value="true"/&gt;
            &lt;!-- 设置为true时，如果pageSize=0或者RowBounds.limit = 0就会查询出全部的结果 --&gt;
            &lt;!-- （相当于没有执行分页查询，但是返回结果仍然是Page类型）--&gt;
            &lt;property name="pageSizeZero" value="true"/&gt;
            &lt;!-- 3.3.0版本可用 - 分页参数合理化，默认false禁用 --&gt;
            &lt;!-- 启用合理化时，如果pageNum&lt;1会查询第一页，如果pageNum&gt;pages会查询最后一页 --&gt;
            &lt;!-- 禁用合理化时，如果pageNum&lt;1或pageNum&gt;pages会返回空数据 --&gt;
            &lt;property name="reasonable" value="true"/&gt;
            &lt;!-- 3.5.0版本可用 - 为了支持startPage(Object params)方法 --&gt;
            &lt;!-- 增加了一个`params`参数来配置参数映射，用于从Map或ServletRequest中取值 --&gt;
            &lt;!-- 可以配置pageNum,pageSize,count,pageSizeZero,reasonable,orderBy,不配置映射的用默认值 --&gt;
            &lt;!-- 不理解该含义的前提下，不要随便复制该配置 --&gt;
            &lt;property name="params" value="pageNum=start;pageSize=limit;"/&gt;
            &lt;!-- 支持通过Mapper接口参数来传递分页参数 --&gt;
            &lt;property name="supportMethodsArguments" value="true"/&gt;
            &lt;!-- always总是返回PageInfo类型,check检查返回类型是否为PageInfo,none返回Page --&gt;
            &lt;property name="returnPageInfo" value="check"/&gt;
        &lt;/plugin&gt;
    &lt;/plugins&gt;
&lt;/configuration&gt;</pre>
<p>3、在配置Spring配置文件中，配置Mybatis的SqlSessionFactory时，需要把mybatis-config.xml添加到属性中</p>
<pre>&lt;!-- SqlSessionFactory --&gt;
    &lt;bean id="sessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;
        &lt;!--设置数据源--&gt;
        &lt;property name="dataSource" ref="dataSource"&gt;&lt;/property&gt;
        &lt;!--设置映射文件--&gt;
        &lt;property name="mapperLocations" value="classpath:mybatis/sqlmap/mapper/*.xml"&gt;&lt;/property&gt;
        &lt;!--设置pageHelper--&gt;
        &lt;property name="configLocation" value="classpath:mybatis/mybatis-config.xml"&gt;&lt;/property&gt;
    &lt;/bean&gt;</pre>
<p>4、使用Mybatis的mapper接口进行查询，在查询时，需要使用PageHelper.startPage方法</p>
<pre>@Test
    public void testSelectAll() {
        Page&lt;Doctor&gt; page = PageHelper.startPage(1, 3);
        //selectAll查询出的List即为上面定义的page
        doctorMapper.selectAll();
        //注意：
        //使用PageHelper.startPage只是针对接下来的一条查询语句，
        //如果又查询了一次数据，则还需要使用一次PageHelper.startPage
        logger.info("获取所有Doctor信息，获得记录数：{}", page.size());
        logger.info("获取所有Doctor信息，获得记录：{}", page);
        //使用PageInfo封装
        PageInfo&lt;Doctor&gt; info = new PageInfo&lt;Doctor&gt;(page);
        logger.info("info.getPages:{}",info.getPages());
    }</pre>
<p>5、Page对象继承了ArrayList，因此在使用了PageHelper.startPage之后，Page即为查询到的数据，并且在Page中还额外封装了pageNum，pageSize等属性，还可以使用PageInfo封装Page，PageInfo中有更多的分页属性，例如isFirstPage是否为首页、isLastPage是否为末尾、hasNextPage是否存在下一页等。</p>
<p>http://www.cnblogs.com/cksvsaaa/p/6036068.html</p>
<p>application.properties中的配置</p>
<pre>pagehelper.helperDialect=mysql
pagehelper.offset-as-page-num=true
pagehelper.reasonable=false
pagehelper.supportMethodsArguments=true
pagehelper.row-bounds-with-count=true</pre>
<p> </p>
<pre>import org.springframework.boot.context.properties.ConfigurationProperties;

import java.util.Properties;

@ConfigurationProperties(prefix = PageHelperProperties.PAGE_HELPER_PREFIX)
public class PageHelperProperties {
    public static final String PAGE_HELPER_PREFIX = "pagehelper";

    private Properties properties = new Properties();

    public Properties getProperties() {
        return properties;
    }

    public String getOffsetAsPageNum() {
        return properties.getProperty("offsetAsPageNum");
    }

    public void setOffsetAsPageNum(String offsetAsPageNum) {
        properties.setProperty("offsetAsPageNum", offsetAsPageNum);
    }

    public String getRowBoundsWithCount() {
        return properties.getProperty("rowBoundsWithCount");
    }

    public void setRowBoundsWithCount(String rowBoundsWithCount) {
        properties.setProperty("rowBoundsWithCount", rowBoundsWithCount);
    }

    public String getPageSizeZero() {
        return properties.getProperty("pageSizeZero");
    }

    public void setPageSizeZero(String pageSizeZero) {
        properties.setProperty("pageSizeZero", pageSizeZero);
    }

    public String getReasonable() {
        return properties.getProperty("reasonable");
    }

    public void setReasonable(String reasonable) {
        properties.setProperty("reasonable", reasonable);
    }

    public String getSupportMethodsArguments() {
        return properties.getProperty("supportMethodsArguments");
    }

    public void setSupportMethodsArguments(String supportMethodsArguments) {
        properties.setProperty("supportMethodsArguments", supportMethodsArguments);
    }

    public String getDialect() {
        return properties.getProperty("dialect");
    }

    public void setDialect(String dialect) {
        properties.setProperty("dialect", dialect);
    }

    public String getHelperDialect() {
        return properties.getProperty("helperDialect");
    }

    public void setHelperDialect(String helperDialect) {
        properties.setProperty("helperDialect", helperDialect);
    }

    public String getAutoRuntimeDialect() {
        return properties.getProperty("autoRuntimeDialect");
    }

    public void setAutoRuntimeDialect(String autoRuntimeDialect) {
        properties.setProperty("autoRuntimeDialect", autoRuntimeDialect);
    }

    public String getAutoDialect() {
        return properties.getProperty("autoDialect");
    }

    public void setAutoDialect(String autoDialect) {
        properties.setProperty("autoDialect", autoDialect);
    }

    public String getCloseConn() {
        return properties.getProperty("closeConn");
    }

    public void setCloseConn(String closeConn) {
        properties.setProperty("closeConn", closeConn);
    }

    public String getParams() {
        return properties.getProperty("params");
    }

    public void setParams(String params) {
        properties.setProperty("params", params);
    }
}</pre>
<p> </p>
<p> </p>
<pre>import com.github.pagehelper.PageInterceptor;
import org.apache.ibatis.session.SqlSessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.bind.RelaxedPropertyResolver;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.EnvironmentAware;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;

import javax.annotation.PostConstruct;
import java.util.Map;
import java.util.Properties;

@Configuration
@ConditionalOnClass(SqlSessionFactory.class)
@EnableConfigurationProperties(PageHelperProperties.class)
public class PageHelperConfig implements EnvironmentAware {

    @Autowired
    private SqlSessionFactory sqlSessionFactory;

    @Autowired
    private PageHelperProperties pageHelperProperties;

    private RelaxedPropertyResolver resolver;

    @Override
    public void setEnvironment(Environment environment) {
        resolver = new RelaxedPropertyResolver(environment, "pagehelper.");
    }

    @PostConstruct
    public void addPageInterceptor() {
        PageInterceptor interceptor = new PageInterceptor();
        Properties properties = pageHelperProperties.getProperties();
        Map&lt;String, Object&gt; subProperties = resolver.getSubProperties("");
        for (String key : subProperties.keySet()) {
            if (!properties.containsKey(key)) {
                properties.setProperty(key, resolver.getProperty(key));
            }
        }
        interceptor.setProperties(properties);
        sqlSessionFactory.getConfiguration().addInterceptor(interceptor);
    }

}</pre>
<p> </p>
<p>通用mapper的配置：</p>
<pre>import com.github.pagehelper.PageInterceptor;
import com.tangcheng.db.util.MyMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import tk.mybatis.spring.mapper.MapperScannerConfigurer;

import java.util.Properties;

@Configuration
public class MybatisConfig {

    private static final Logger LOGGER = LoggerFactory.getLogger(MybatisConfig.class);

    @Bean
    public MapperScannerConfigurer mapperScannerConfigurer() {
        //此处使用的是tk.mybatis.spring.mapper.MapperScannerConfigurer
        MapperScannerConfigurer mapperScannerConfigurer = new MapperScannerConfigurer();
        mapperScannerConfigurer.setMarkerInterface(MyMapper.class);
        mapperScannerConfigurer.setBasePackage("com.tangcheng.db.mapper");
        Properties properties = new Properties();
        properties.put("notEmpty", false);//notEmpty：insert和update中，是否判断字符串类型!=''，少数方法会用到
        properties.put("IDENTITY", "MYSQL");//取回主键的方式，
        properties.put("style", "camelhump");//实体和表转换时的约定规则，默认驼峰转下划线。注解@Table和@Column优先级高于此配置
        //http://git.oschina.net/free/Mapper/blob/master/wiki/mapper3/2.Integration.md
        mapperScannerConfigurer.setProperties(properties);
        return mapperScannerConfigurer;
    }

    /**
     * PageHelper Parameters
     * &lt;p&gt;
     * PageHelper provides several optional parameters, these parameters when used in accordance with the above two examples to configuration.
     * &lt;p&gt;
     * Optional parameters as follows:
     * &lt;p&gt;
     * dialect: Default paging using PageHelper way, if you want to implement your own page logic, you can implement Dialect(com.github.pagehelper.Dialect) interface, and then configure the attribute to the fully qualified name of the implementing class.
     * The following parameters are the parameters for the default dialect case. When implemented using a custom dialect, the following parameter has no effect.
     * &lt;p&gt;
     * helperDialect: PageHelper will detect the current database url by default, automatically select the corresponding database dialect. You can configure helperDialect Property to specify the dialect. You can use the following abbreviations :
     * oracle, mysql, mariadb, sqlite, hsqldb, postgresql, db2, sqlserver, informix, h2, sqlserver2012, derby.
     * You can also implement AbstractHelperDialect, and then configure the attribute to achieve the fully qualified class name.
     * Special note : When using the SqlServer2012 database, you need to manually specify for sqlserver2012, otherwise it will use the SqlServer2005 for paging.
     * &lt;p&gt;
     * offsetAsPageNum: Default value is false, This parameter is valid for RowBounds as a pagination parameter. When this parameter is set to true, theoffset parameter in RowBounds is used aspageNum.
     * &lt;p&gt;
     * rowBoundsWithCount: Default value is false, When this parameter is set to true, PageHelper will execute count query.
     * &lt;p&gt;
     * pageSizeZero: Default value is false, When this parameter is set to true, if pageSize=0 or RowBounds.Limit = 0 will query all the results (the equivalent of a Paged query did not execute, but the return type of the result is still Page).
     * &lt;p&gt;
     * reasonable: Rationalization of paging parameters, Default value is false。 When this parameter is set to true,pageNum &lt;= 0 will query the first page, PageNum&gt; pages (over the total number), will query the last page. Default false, the query directly based on parameters.
     * &lt;p&gt;
     * params: In support of startPage(Object params) method, The parameter is added to configure the parameter mapping for the value from the object based on the attribute name, you can configure pageNum,pageSize,count,pageSizeZero,reasonable, Default value is pageNum=pageNum;pageSize=pageSize;count=countSql;reasonable=reasonable;pageSizeZero=pageSizeZero。
     * &lt;p&gt;
     * supportMethodsArguments: Support via the Mapper interface parameters to pass the page parameter, the default value is 'false'. The use of methods can refer to the test code in the com.github.pagehelper.test.basic package under theArgumentsMapTest and ArgumentsObjTest.
     * &lt;p&gt;
     * autoRuntimeDialect: Default value is false。When set to true, it is possible to automatically recognize pagination of the corresponding dialect at run time from multiple data sources (Does not support automatic selection of sqlserver2012, can only usesqlserver), usage and precautions refer to the following Scene 5.
     * &lt;p&gt;
     * closeConn: Default value is true。 When you use a runtime dynamic data source or do not set the helperDialect property, PageHelper will automatically get the database type, then a database connection is automatically obtained, This property is used to set whether to close the connection, the default true close. When 'false' is set, It will not close the connection.
     * &lt;p&gt;
     * 4. How to choose Configure these parameters
     * &lt;p&gt;
     * Here are a few examples for some of the parameters may be used.
     * &lt;p&gt;
     * Scene 1
     * &lt;p&gt;
     * If you are still in with a way to call a namespace like iBATIS, you might use rowBoundsWithCount. If you want to count when the paging query query, you need to set this parameter to true.
     * &lt;p&gt;
     * Note: PageRowBounds also need true.
     * &lt;p&gt;
     * Scene 2
     * &lt;p&gt;
     * If you are still in with a way to call a namespace like iBATIS, If you think RowBounds in the two parametersoffset, limit not as good as pageNum, pageSize easy to understand. You can use the offsetAsPageNum parameter, when the parameter is set to true, offset as pageNum, limit and pageSize mean the same thing.
     * &lt;p&gt;
     * Scene 3
     * &lt;p&gt;
     * If you feel you have to paginate a page somewhere and you still want to query all the results with control parameters. You can configure pageSizeZero totrue, After configuration, when pageSize = 0 or RowBounds.limit = 0 will query all the results.
     * &lt;p&gt;
     * Scene 4
     * &lt;p&gt;
     * If you want the user to enter the page number is not in the legal scope (the first page to the last page) to correctly respond to the correct results page, Then you can configure reasonable totrue, and if pageNum &lt;= 0 will query the first page, the pageNum&gt; pages(total pages) will query the last page.
     * &lt;p&gt;
     * Scene 5
     * &lt;p&gt;
     * If you configure dynamic data sources in Spring and connect different types of databases, you can configure autoRuntimeDialect totrue, which will use matching pagination queries when using different data sources. In this case, you also need to pay attention to the closeConn parameter, because the type of access to the data source will get a database connection, so the need to control this parameter to obtain a connection, whether to close the connection.
     * &lt;p&gt;
     * Default is true, and some database connections can not be closed after the follow-up database operations. And some database connections will not be closed soon because the number of connections out of the database caused no response. Therefore, when using this feature, in particular, you need to pay attention to whether the use of the data source needs to close the database connection.
     * &lt;p&gt;
     * When you do not use dynamic data sources but only automatically get helperDialect, the database connection will only get once, so there is no need to worry about whether this connection will lead to a database error, but also according to the characteristics of the data source to choose whether to close the connection.
     * https://github.com/pagehelper/Mybatis-PageHelper/blob/master/wikis/en/HowToUse.md
     * &lt;p&gt;
     * &lt;p&gt;
     * 分页插件参数介绍
     * &lt;p&gt;
     * 分页插件提供了多个可选参数，这些参数使用时，按照上面两种配置方式中的示例配置即可。
     * &lt;p&gt;
     * 分页插件可选参数如下：
     * &lt;p&gt;
     * dialect：默认情况下会使用 PageHelper 方式进行分页，如果想要实现自己的分页逻辑，可以实现 Dialect(com.github.pagehelper.Dialect) 接口，然后配置该属性为实现类的全限定名称。
     * 下面几个参数都是针对默认 dialect 情况下的参数。使用自定义 dialect 实现时，下面的参数没有任何作用。
     * &lt;p&gt;
     * helperDialect：分页插件会自动检测当前的数据库链接，自动选择合适的分页方式。 你可以配置helperDialect属性来指定分页插件使用哪种方言。配置时，可以使用下面的缩写值：
     * oracle,mysql,mariadb,sqlite,hsqldb,postgresql,db2,sqlserver,informix,h2,sqlserver2012,derby
     * 特别注意：使用 SqlServer2012 数据库时，需要手动指定为 sqlserver2012，否则会使用 SqlServer2005 的方式进行分页。
     * 你也可以实现 AbstractHelperDialect，然后配置该属性为实现类的全限定名称即可使用自定义的实现方法。
     * &lt;p&gt;
     * offsetAsPageNum：默认值为 false，该参数对使用 RowBounds 作为分页参数时有效。 当该参数设置为 true 时，会将 RowBounds 中的 offset 参数当成 pageNum 使用，可以用页码和页面大小两个参数进行分页。
     * &lt;p&gt;
     * rowBoundsWithCount：默认值为false，该参数对使用 RowBounds 作为分页参数时有效。 当该参数设置为true时，使用 RowBounds 分页会进行 count 查询。
     * &lt;p&gt;
     * pageSizeZero：默认值为 false，当该参数设置为 true 时，如果 pageSize=0 或者 RowBounds.limit = 0 就会查询出全部的结果（相当于没有执行分页查询，但是返回结果仍然是 Page 类型）。
     * &lt;p&gt;
     * reasonable：分页合理化参数，默认值为false。当该参数设置为 true 时，pageNum&lt;=0 时会查询第一页， pageNum&gt;pages（超过总数时），会查询最后一页。默认false 时，直接根据参数进行查询。
     * &lt;p&gt;
     * params：为了支持startPage(Object params)方法，增加了该参数来配置参数映射，用于从对象中根据属性名取值， 可以配置 pageNum,pageSize,count,pageSizeZero,reasonable，不配置映射的用默认值， 默认值为pageNum=pageNum;pageSize=pageSize;count=countSql;reasonable=reasonable;pageSizeZero=pageSizeZero。
     * &lt;p&gt;
     * supportMethodsArguments：支持通过 Mapper 接口参数来传递分页参数，默认值false，分页插件会从查询方法的参数值中，自动根据上面 params 配置的字段中取值，查找到合适的值时就会自动分页。 使用方法可以参考测试代码中的 com.github.pagehelper.test.basic 包下的 ArgumentsMapTest 和 ArgumentsObjTest。
     * &lt;p&gt;
     * autoRuntimeDialect：默认值为 false。设置为 true 时，允许在运行时根据多数据源自动识别对应方言的分页 （不支持自动选择sqlserver2012，只能使用sqlserver），用法和注意事项参考下面的场景五。
     * &lt;p&gt;
     * closeConn：默认值为 true。当使用运行时动态数据源或没有设置 helperDialect 属性自动获取数据库类型时，会自动获取一个数据库连接， 通过该属性来设置是否关闭获取的这个连接，默认true关闭，设置为 false 后，不会关闭获取的连接，这个参数的设置要根据自己选择的数据源来决定。
     * &lt;p&gt;
     * 重要提示：
     * &lt;p&gt;
     * 当 offsetAsPageNum=false 的时候，由于 PageNum 问题，RowBounds查询的时候 reasonable 会强制为 false。使用 PageHelper.startPage 方法不受影响。
     * &lt;p&gt;
     * 4. 如何选择配置这些参数
     * &lt;p&gt;
     * 单独看每个参数的说明可能是一件让人不爽的事情，这里列举一些可能会用到某些参数的情况。
     * &lt;p&gt;
     * 场景一(rowBoundsWithCount)
     * &lt;p&gt;
     * 如果你仍然在用类似ibatis式的命名空间调用方式，你也许会用到rowBoundsWithCount， 分页插件对RowBounds支持和 MyBatis 默认的方式是一致，默认情况下不会进行 count 查询，如果你想在分页查询时进行 count 查询， 以及使用更强大的 PageInfo 类，你需要设置该参数为 true。
     * &lt;p&gt;
     * 注： PageRowBounds 想要查询总数也需要配置该属性为 true。
     * &lt;p&gt;
     * 场景二(offsetAsPageNum)
     * &lt;p&gt;
     * 如果你仍然在用类似ibatis式的命名空间调用方式，你觉得 RowBounds 中的两个参数 offset,limit 不如 pageNum,pageSize 容易理解， 你可以使用 offsetAsPageNum 参数，将该参数设置为 true 后，offset会当成 pageNum 使用，limit 和 pageSize 含义相同。
     * &lt;p&gt;
     * 场景三(pageSizeZero)
     * &lt;p&gt;
     * 如果觉得某个地方使用分页后，你仍然想通过控制参数查询全部的结果，你可以配置 pageSizeZero 为 true， 配置后，当 pageSize=0 或者 RowBounds.limit = 0 就会查询出全部的结果。
     * &lt;p&gt;
     * 场景四(reasonable)
     * &lt;p&gt;
     * 如果你分页插件使用于类似分页查看列表式的数据，如新闻列表，软件列表， 你希望用户输入的页数不在合法范围（第一页到最后一页之外）时能够正确的响应到正确的结果页面， 那么你可以配置 reasonable 为 true，这时如果 pageNum&lt;=0 会查询第一页，如果 pageNum&gt;总页数 会查询最后一页。
     * &lt;p&gt;
     * 场景五(autoRuntimeDialect,closeConn)
     * &lt;p&gt;
     * 如果你在 Spring 中配置了动态数据源，并且连接不同类型的数据库，这时你可以配置 autoRuntimeDialect 为 true，这样在使用不同数据源时，会使用匹配的分页进行查询。 这种情况下，你还需要特别注意 closeConn 参数，由于获取数据源类型会获取一个数据库连接，所以需要通过这个参数来控制获取连接后，是否关闭该连接。 默认为 true，有些数据库连接关闭后就没法进行后续的数据库操作。而有些数据库连接不关闭就会很快由于连接数用完而导致数据库无响应。所以在使用该功能时，特别需要注意你使用的数据源是否需要关闭数据库连接。
     * &lt;p&gt;
     * 当不使用动态数据源而只是自动获取 helperDialect 时，数据库连接只会获取一次，所以不需要担心占用的这一个连接是否会导致数据库出错，但是最好也根据数据源的特性选择是否关闭连接。
     * https://github.com/pagehelper/Mybatis-PageHelper/blob/master/wikis/zh/HowToUse.md
     * eg:http://www.jianshu.com/p/b0af2c0a7a9d
     *
     * @return
     */
//    @Bean
    public PageInterceptor pageInterceptor() {
        /**
         * The MyBatis-Spring-Boot-Starter will detects beans that implements following interface provided by MyBatis.
         Interceptor
         DatabaseIdProvider
         http://www.mybatis.org/spring-boot-starter/mybatis-spring-boot-autoconfigure/
         */
        PageInterceptor interceptor = new PageInterceptor();
        Properties properties = new Properties();
        properties.put("helperDialect", "mysql");//配置helperDialect属性来指定分页插件使用哪种方言。配置时，可以使用下面的缩写值：oracle,mysql,mariadb
        properties.put("offsetAsPageNum", true);//offsetAsPageNum：默认值为 false，该参数对使用 RowBounds 作为分页参数时有效。 当该参数设置为 true 时，会将 RowBounds 中的 offset 参数当成 pageNum 使用，可以用页码和页面大小两个参数进行分页。
        properties.put("rowBoundsWithCount", false);//默认值为false,使用 RowBounds 分页不会进行 count 查询
        properties.put("pageSizeZero", false);//默认值为 false，当该参数设置为 true 时，如果 pageSize=0 或者 RowBounds.limit = 0 就会查询出全部的结果
        properties.put("reasonable", false);//默认值为false。当该参数设置为 true 时，pageNum&lt;=0 时会查询第一页， pageNum&gt;pages（超过总数时），会查询最后一页
        properties.put("supportMethodsArguments", true);//支持通过 Mapper 接口参数来传递分页参数，默认值false
        interceptor.setProperties(properties);
        return interceptor;
    }

}</pre>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 07:12:03</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e6%8f%92%e4%bb%b6/" title="插件">插件</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/spring/" title="spring">spring</a>, <a href="https://www.iamivan.net/tag/mybatis/" title="mybatis">mybatis</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Spring Boot MyBatis 通用Mapper插件集成  good的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9EVL4M.html" rel="bookmark">Spring Boot MyBatis 通用Mapper插件集成</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看本文之前,请确保你已经在SpringBoot中集成MyBatis,并能正常使用. 如果没有,那么请先移步 http://blog.csdn.net/catoop/article/details/50553714 做了解后,再按本文步骤操作. 使用MyBatis在我们通过xml集中配置SQL,并通过创建接口Mapper文件来完成持久化DAO层(mybatis内部使用的是动态代理,所以我们不需要自己编写实现类). 然而在实际开发中,单表操作非常多,如果你也想像JPA.JDBC那样做一个所谓的Bas			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJA084p.html" rel="bookmark">spring boot&plus;mybatis的整合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 spring boot+mybatis的整合 在官网找了很久没看到有关于spring boot跟mybatis的整合,求高手指点 解决方案 完整参考:http://blog.csdn.net/xiaoyu411502/article/details/48164311 解决方案二: 官方版本没有提供支持,好像只能使用原始的方法整合了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zw5rxnM.html" rel="bookmark">Mybatis 通用 Mapper 2&period;2&period;0 发布</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Mybatis通用Mapper极其方便的使用Mybatis单表的增删改查 2.2.0 新增SqlMapper,可以使用MyBatis直接执行sql,详细文档 2.2.0版本之后,通过SqlMapper可以支持多表的操作,但是需要在代码中直接写SQL. 即使不使用通用mapper,相信SqlMapper也一定符合部分人的需求. 示例: selectList: //查询,返回List&lt;Map&gt; List&lt;Map&lt;String, Object&gt;&gt; list = sqlMapp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1X6kz.html" rel="bookmark">Mybatis通用Mapper</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				极其方便的使用Mybatis单表的增删改查 项目地址:http://git.oschina.net/free/Mapper 优点? 不客气的说,使用这个通用Mapper甚至能改变你对Mybatis单表基础操作不方便的想法,使用它你能简单的使用单表的增删改查,包含动态的增删改查. 程序使用拦截器实现具体的执行Sql,完全使用原生的Mybatis进行操作. 你还在因为数据库表变动重新生成xml吗?还是要手动修改自动生成的insert|update|delete的xml呢?赶紧使用通用Mapper,表			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBgjNdM.html" rel="bookmark">Spring Boot MyBatis 连接数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近比较忙,没来得及抽时间把MyBatis的集成发出来,其实mybatis官网在2015年11月底就已经发布了对SpringBoot集成的Release版本,Github上有代码:https://github.com/mybatis/mybatis-spring-boot 前面对JPA和JDBC连接数据库做了说明,本文也是参考官方的代码做个总结. 先说个题外话,SpringBoot默认使用 org.apache.tomcat.jdbc.pool.DataSource 现在有个叫 HikariCP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M607rOz.html" rel="bookmark">Spring boot Mybatis</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近刚接触Spring boot,正是因为他的及简配置方便开发,促使我下定决心要用它把之前写的项目重构,那么问题来了,spring boot怎么整合mybatis呢,下面几个配置类来搞定. 在我的代码当中是实现了数据库读写分离的,所以代码仅做参考,如有需要可以加我微信:benyzhous [后续更新]   1.文件结构       DataBaseConfiguration.java用来获取数据库连接配置信息,配置从application.properties中读取   MybatisConfi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNKXBp.html" rel="bookmark">mybatis通用mapper的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				       项目中持久层封装了两套,一个hibernate,一个是mybatis.hibernate中封装了一些通用的方法,但是mybatis中没有,基于这个需求开始使用mybatis的通用mapper.        通用mapper有什么好处呢?以往我们使用mapper文件都是自己写sql语句,针对的是单个实体,也就是每个实体都有其对应的mapper文件.使用通用mapper给我们带来了极大的方便,它不需要mapper.xml文件,只需我们调用相应的接口,引入jar包再进行简单的配置就好了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3r0QJz.html" rel="bookmark">Spring Boot集成持久化Quartz定时任务管理和界面展示</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 本文是对之前的一篇文章Spring+SpringMVC+mybatis+Quartz整合代码部分做的一个修改和补充, 其中最大的变化就是后台框架变成了Spring Boot. 本工程所用到的技术或工具有: Spring Boot Mybatis Quartz PageHelper VueJS ElementUI MySql数据库 正文 配置 本例中仍然是使用mysql数据库作为Quartz任务持久化的存储载体.对于如何在Mysql数据库中建立表,在上一篇Spring+SpringMVC+m			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQB3dOM.html" rel="bookmark">Spring Boot 集成 FreeMarker 详解案例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载自 并发编程网 - ifeve.com一.Springboot 那些事 SpringBoot 很方便的集成 FreeMarker ,DAO 数据库操作层依旧用的是 Mybatis,本文将会一步一步到来如何集成 FreeMarker 以及配置的详解: Springboot 那些事: 系类文章: &lt;Spring Boot 之 RESRful API 权限控制&gt; &lt;Spring Boot 之 HelloWorld详解&gt; &lt;Springboot 整合 Mybatis 的完整 We			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeo99M.html" rel="bookmark" class="title">jira-为啥现在去JIRA官网申请试用30天的license失败</a>
					<div>
						问题描述 为啥现在去JIRA官网申请试用30天的license失败 sign up atlassian 提示request is missing required from field 'recapt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkANob.html" rel="bookmark" class="title">iocp-IOCP参考资料入门资料推荐</a>
					<div>
						问题描述 IOCP参考资料入门资料推荐 最近老大布置了任务,学习IOCP,给了我一个源代码,包括客户端和服务端,但是代码看不懂啊,没有注释可看,有没有什么关于IOCP入门的资料书籍什么的推荐啊~谢谢了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpmjo3z.html" rel="bookmark" class="title">如何有条件的分步删除数据表中的记录</a>
					<div>
						数据|条件 如何有条件的分步删除数据表中的记录作者:eygle出处:http://blog.eygle.com日期:February 22, 2005« 自己动手,丰衣足食 | Blog首页 有时候我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKxRdM.html" rel="bookmark" class="title">J2ME中使用缓存将屏幕内容存储为Image</a>
					<div>
						缓存 本文介绍如何将手机屏幕的内容存储为Image对象,这里认为手机屏幕上显示的是一个Canvas.完成这一个功能的思想就是使用缓冲机制.我们不能直接获得Canvas上的像素,因此不能直接从Canva ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvLArz.html" rel="bookmark" class="title">SQL中的两个值得注意的特殊符号</a>
					<div>
						在SQL中,表示字符串得引号强烈建议使用单引号(').虽然MySQL也可以使用双引号(&quot;),但是为了和SQL Server和Oracle统一,建议都使用单引号.如果在字符串中也有单引号出现的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4weY8p.html" rel="bookmark" class="title">Linux常用shell命令</a>
					<div>
						本文章记录我在linux系统下常用或有用的系统级命令,包括软硬件查看.修改命令,有CPU.内存.硬盘.网络.系统管理等命令.但本文不打算介绍生僻命令,也不介绍各个linux发行版下的特有命令,且以后会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKA35p.html" rel="bookmark" class="title">Linux下GitLab如何安装部署</a>
					<div>
						  一, GitLab 简介 现在,GitHub已经成为首选的代码托管平台. 因为它又很多很棒的功能,操作简单,几乎所有的开发者都喜欢它.Gitlab 是一个很棒的Git托管服务,几乎像GitHub一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRqZDz.html" rel="bookmark" class="title">如何给WPS文字插入背景音乐</a>
					<div>
						  插入对象法实现WPS文字加上背景音乐 1.如果仅仅是想要在编辑文档的同时播放音乐,还是比较简单的.在当前文档中,从&quot;插入&quot;菜单中选择&quot;对象&quot;,然后选择&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6V3Vz.html" rel="bookmark" class="title">清理所有帐号下的cookie</a>
					<div>
						由于cookie的删除工作一般都只针对本帐号,所以在很多人登录过的电脑中,我们如果需要清理cookie的话需要分别登录各帐号再删除,或用有管理员权限的帐号登录再分别打开各个帐号来删除,而如果帐号有几十 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7aAVb.html" rel="bookmark" class="title">e信wifi共享精灵使用方法</a>
					<div>
						  1e信客户端 2.wifi共享精灵 刚开学的时候,湖北的同学们有没有失落了一阵子,因为发现wifi共享精灵使用不了了.不知道用&quot;道高一尺,魔高一丈&quot;适不适合形容wifi共享与E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYn1Xb.html" rel="bookmark" class="title">Win7系统访问指定网页的2个妙招</a>
					<div>
						办法1 修改Hosts文件 hosts文件位于 Windows/system32/drivers/etc/目录下,用于控制域名访问.我想到的办法修改hosts文件,让DNS域名解析这些网站都指向127 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr370yp.html" rel="bookmark" class="title">用Photoshop制作数字碎片效果</a>
					<div>
						  最终效果. 1.第一步:(准备工作) 找好素材图片 . 2.设置笔刷 (当然,你可以网上自己下载类似的) 按快捷键B选择画笔形状-带阴影的画笔-投影方形–35像素(Photoshop自带此类画笔) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mywy5lz.html" rel="bookmark" class="title">浩方电竞平台怎么用？</a>
					<div>
						  感谢您使用浩方新平台,我们将在下文为您简单介绍如何进行平台登陆和游戏新手引导 首先下载浩方新平台,解压双击进入新平台主界面,即可看到平台功能导航栏.左侧游戏管理栏.联机游戏和右侧最近游戏栏. 导航 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB6nVz.html" rel="bookmark" class="title">由一道百度之星题目写起 谈谈编程中的分类的思想</a>
					<div>
						百度之星,是全球最大的中文搜索引擎,百度公司面向中国高校学生和编程爱好者所举办的高水平的程序设计大赛.他所考试的题目,全部都是算法的题目. 鄙人虽然是一个非主流的.net程序员,在工作之余,喜爱算法. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQ9Dap.html" rel="bookmark" class="title">利用反射获取静态变量值的问题&period;</a>
					<div>
						问题描述 publicclassSVC(){publicstaticintcount=0;}privatevoidtest118(objectobj,stringname){while(true){T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7Rnnz.html" rel="bookmark" class="title">html-HTML  font-size，手机上显示的和设置的不同</a>
					<div>
						问题描述 HTML font-size,手机上显示的和设置的不同 不能正常的显示 解决方案 是不是不支持 font-style 你可以试试,把 font-size 属性 放在 p{ } 里试试,就是试 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE3KvM.html" rel="bookmark" class="title">&period;NET中IO体系结构</a>
					<div>
						  基于字节的流 是基于Stream这个抽象类的子类.常见的有: ①Filesteam ②MemoryStream ③NetworkStream  该流可以对任意文件进行读或写的操作.实际开发中,常常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AEJPz.html" rel="bookmark" class="title">专网企业获发基础电信牌照：运营商不必紧张</a>
					<div>
						日前,中国交通通信信息中心取得工业和信息化部颁发的&lt;中华人民共和国基础电信业务经营许可证&gt;,正式获得我国基础电信业务经营一级资质,跻身国家基础电信运营商之列的消息引爆了整个通信圈. 这则消 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXym6z.html" rel="bookmark" class="title">navicat for mysql 的用法</a>
					<div>
						问题描述 navicat for mysql 的用法 为什么我得navicat上面没有显示和sql server 连接的图标啊?求解 解决方案 ...navicat 只能用于 mysql ,不能用于链 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAKnvp.html" rel="bookmark" class="title">辣妈帮首创找优惠功能 或涉足O2O市场</a>
					<div>
						生活服务行业都在不同程度的被O2O改变着,比如你可以通过手机APP打车.叫外卖.修手机.洗衣服,现在O2O这股热潮又开始蔓延到女性行业.近日,国内最大的移动女性社区辣妈帮推出了&quot;找优惠&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rn6Az.html" rel="bookmark" class="title">在线支付功能的设计及其实现</a>
					<div>
						----------------------------------------------------------------------------------------------[版权申明: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo94VM.html" rel="bookmark" class="title">最新诈骗手段 网购的货直达骗子手中</a>
					<div>
						浙大研究生小张省吃俭用了一年,终于在网上订到了时下最潮的诺基亚920手机.这手机,价值5000多元呢. 小张和卖家之间是通过http://www.aliyun.com/zixun/aggregatio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnx6JM.html" rel="bookmark" class="title">中移动领跑3G上半场竞争</a>
					<div>
						每经记者 陈未临 发自上海 日前,中国移动.中国电信.中国联通相继公布了2010财年的中期业绩.截至今年6月30日,中国移动.中国电信.中国联通的3G用户数分别为1046万.718万与756万,中国移 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7wEaz.html" rel="bookmark" class="title">关于ACTION里面获得URL参数的问题</a>
					<div>
						问题描述 简单的把问题概述下访问自己测试的http://127.0.0.1:8888/TestUrl/do.do?m=t&amp;id=%C6%DF%C6%DFIT%D6%D0%B9%FA在ACTIO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn802Ob.html" rel="bookmark" class="title">Colortip基于jquery的信息提示框插件在IE6下面的显示问题修正方法&lowbar;jquery</a>
					<div>
						今天又回顾了一下这个插件,然后发现它在IE6下面工作的时候,显示起来是不正常的,tip经常出现在很离谱的位置.问题还有,由于tip的显示效果没有用到任何图像,都是纯的CSS,所以里面用CSS实现的三角 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkPKoM.html" rel="bookmark" class="title">Dreamweaver jQuery智能提示插件&comma;支持版本提示&comma;支持1&period;6api&lowbar;jquery</a>
					<div>
						例如:1.0 =&gt; 1.0.0:1.1 =&gt; 1.1.0 1.增加jQuery版本提示: 2.增加event事件智能提示: 3.增加delegate和undelegate 智能提示 del ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z441KYz.html" rel="bookmark" class="title">asp&period;net中httpModule计算页面的执行时间</a>
					<div>
						ASP.NET系统中默认的HttpModule: DefaultAuthenticationModule 确保上下文中存在 Authentication 对象.无法继承此类. FileAuthoriz ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW0WZz.html" rel="bookmark" class="title">jquery实现未经美化的简洁TAB菜单效果&lowbar;jquery</a>
					<div>
						本文实例讲述了jquery实现未经美化的简洁TAB菜单效果.分享给大家供大家参考.具体如下: 这是一个看上去未经美化的简洁TAB选项卡,触发类的动作都是完整的,有兴趣的自己进行美化,美化漂亮了还是相当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmPPDp.html" rel="bookmark" class="title">ASP&period;NET虚拟主机的重大安全隐患&lpar;三&rpar;</a>
					<div>
						解决方案 将FSO组件和删除或改名的方式我们不再过多的加以说明了,这一类的解决方法网络上已经有很多文章介绍了. 另外还有一种关于ASP的FSO组件漏洞的相应解决方案,即根据用户设置权限.在IIS里,可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDk6xXp.html" rel="bookmark" class="title">阿里云宣布0元注册域名 云服务有了免费入口</a>
					<div>
						据悉,从5月20日起,企业只要新注册阿里云会员并完成实名认证,均可免费注册一个.com或.xin域名,同时可以免费领取的还有虚拟主机和企业邮箱&quot;阿里邮箱&quot;.这是继去年年初推出免费虚 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
